package com.study.sketch.learning.activity;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.graphics.Point;
import android.graphics.PointF;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.SeekBar;
import android.widget.Toast;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.camera.core.Camera;
import androidx.camera.core.CameraSelector;
import androidx.camera.core.ImageCapture;
import androidx.camera.core.Preview;
import androidx.camera.lifecycle.ProcessCameraProvider;
import androidx.camera.view.PreviewView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.ad.maxlibrary.MaxManager;
import com.ad.maxlibrary.onAdAfterAction;
import com.study.sketch.learning.database.MyDb;
import com.study.sketch.learning.manager.Common;
import com.google.common.util.concurrent.ListenableFuture;
import com.study.sketch.learning.SketchingApp;
import com.study.sketch.learning.R;

public class ActivitySketching extends AppCompatActivity implements View.OnTouchListener, View.OnClickListener {
    private CameraSelector cameraSelector;
    private String[] permissions;

    private Camera camera;
    private ImageCapture imageCapture;
    private PreviewView previewView;
    private ImageView imageView;
    private SeekBar seekBar;




    private int MODE;//当前状态
    public static final int MODE_NONE = 0;//无操作
    public static final int MODE_DRAG = 1;//单指操作
    public static final int MODE_SCALE = 2;//双指操作

    private Matrix startMatrix  = new Matrix();
    private Matrix endMatrix = new Matrix();//变化后的矩阵
    private PointF startPointF = new PointF();//初始坐标
    private float distance;//初始距离
    private float scaleMultiple;//缩放倍数

    private ImageView flashIm, imZoom, imBack,imFavorite;
    private ImageView imPhoto;

    private String curBitmapPath;
    private boolean hasPermission = false;
    private boolean isMain;
    private String ismain;

    private ActivityResultLauncher<Intent> intentActivityResultLauncher;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sketching);
        Common.setStatusBarTextColor(this, true);
        Intent intent = getIntent();
        isMain = intent.getBooleanExtra(SketchingApp.Key_ISMAIN, false);

        MaxManager.onLoadAd();

        previewView = findViewById(R.id.preview);
        imageView = findViewById(R.id.image);
        imBack = findViewById(R.id.back);

        seekBar = findViewById(R.id.seekbar);
        flashIm = findViewById(R.id.im_flash);
        imPhoto = findViewById(R.id.im_photo);
        imZoom = findViewById(R.id.im_zoom);
        imFavorite = findViewById(R.id.im_favorite);



        curBitmapPath = getIntent().getStringExtra(SketchingApp.Key_Camera);

        boolean b = MyDb.queryIsLike(curBitmapPath);
        imFavorite.setSelected(b);

        intentActivityResultLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
            if (result.getResultCode() == Activity.RESULT_OK && result.getData() != null) {
                Uri imageUri = result.getData().getData();
                if(imageUri!= null){
                    String lastPathSegment = imageUri.getLastPathSegment();
                    int index = lastPathSegment.lastIndexOf("/");
                    String name = lastPathSegment.substring(index+1);
                    double uriFileSize = Common.getUriFileSize(ActivitySketching.this, imageUri);
                    Log.d(SketchingApp.TAG, "------uriFileSize-----" + uriFileSize+"--Mb");
                    if(uriFileSize>=5){
                        Toast.makeText(ActivitySketching.this, getString(R.string.import_im_too_big), Toast.LENGTH_SHORT).show();
                        return;
                    }
                    imageView.setImageURI(imageUri);
                     new Thread(new Runnable() {
                         @Override
                         public void run() {
                             boolean b = Common.saveToInternalStorage(name, imageUri, ActivitySketching.this);
                             if(b){
                                 String importPath = Common.getImportPath(name);
                                 MyDb.insertImport(importPath);
                             }
                         }
                     }).start();


                }

            }

        });

        init();
        initClick();
        MaxManager.startShowMaxAd(this, new onAdAfterAction() {
            @Override
            public void onAction() {

            }
        });
    }



    private void onInitIm(float imW, float imH) {
        Point screen = Common.getScreen(this);
        float newX = screen.x / 2f - imW / 2;
        float newY = screen.y / 2f - imH / 2;
        startMatrix.postTranslate(newX, newY);
        imageView.setImageMatrix(startMatrix);
    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {
        switch (event.getAction() & event.getActionMasked()) {
            case MotionEvent.ACTION_DOWN:

                startMatrix.set(imageView.getImageMatrix());
                endMatrix.set(imageView.getImageMatrix());

                startPointF.set(event.getX(), event.getY());




                MODE = MODE_DRAG;

                break;
            case MotionEvent.ACTION_POINTER_DOWN:

                startMatrix.set(endMatrix);

                distance = Common.getDistance(event);

                MODE = MODE_SCALE;

                break;
            case MotionEvent.ACTION_MOVE://滑动（单+双）
                if (MODE == MODE_DRAG) {//单指滑动时

                    endMatrix.set(startMatrix);
                    //向矩阵传入位移距离
                    endMatrix.postTranslate(event.getX() - startPointF.x, event.getY() - startPointF.y);
                    Log.d("---------------tt", "------ACTION_MOVE-----x=" + event.getX() + "------y=" + event.getY());
                } else if (MODE == MODE_SCALE) {//双指滑动时
                    //计算缩放倍数
                    scaleMultiple = Common.getDistance(event) / distance;
                    //获取初始矩阵
                    endMatrix.set(startMatrix);
                    //向矩阵传入缩放倍数
                    endMatrix.postScale(scaleMultiple, scaleMultiple, startPointF.x, startPointF.y);
                }
                break;
            case MotionEvent.ACTION_UP://单指离开
            case MotionEvent.ACTION_POINTER_UP://双指离开
                //手指离开后，重置状态
                MODE = MODE_NONE;

                break;
        }
        //事件结束后，把矩阵的变化同步到ImageView上
        imageView.setImageMatrix(endMatrix);
        return true;
    }

    @Override
    public void onClick(View v) {
        if (v.equals(imBack)) {

            if (isMain) {
                finish();
            } else {
                finish();
            }

        } else {
            if (!hasPermission) {
                showNoPermission();
                return;
            }
            if (v.equals(flashIm)) {
                boolean selected = flashIm.isSelected();
                flashIm.setSelected(!selected);
                camera.getCameraControl().enableTorch(!selected);
            } else if (v.equals(imPhoto)) {
                MaxManager.startShowMaxAd(ActivitySketching.this, new onAdAfterAction() {
                    @Override
                    public void onAction() {
                        Intent intent = new Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                        intent.setType("image/*");
                        intentActivityResultLauncher.launch(intent);
                    }
                });

            } else if (v.equals(imZoom)) {
                if (seekBar.getVisibility() == View.VISIBLE) {
                    seekBar.setVisibility(View.GONE);
                } else if (seekBar.getVisibility() == View.GONE) {
                    seekBar.setVisibility(View.VISIBLE);
                }
            }else if(v.equals(imFavorite)){
                boolean selected =  imFavorite.isSelected();
                 imFavorite.setSelected(!selected);
                boolean newSelect =  imFavorite.isSelected();
                if(newSelect){
                    MyDb.insertOrUpdateLike(curBitmapPath);
                }else {
                    MyDb.deleteLike(curBitmapPath);

                }
            }
        }

    }

    private void initClick() {
        imBack.setOnClickListener(this);
        flashIm.setOnClickListener(this);
        imPhoto.setOnClickListener(this);
        imZoom.setOnClickListener(this);
        imFavorite.setOnClickListener(this);
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                float v = (seekBar.getMax() - progress) / 10.0f;
                imageView.setAlpha(v);

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    private void init() {
        cameraSelector = CameraSelector.DEFAULT_BACK_CAMERA;
        permissions = new String[]{android.Manifest.permission.CAMERA};
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            permissions = new String[]{android.Manifest.permission.CAMERA, Manifest.permission.READ_MEDIA_IMAGES};
        } else {
            permissions = new String[]{android.Manifest.permission.CAMERA, Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};
        }
        if (!Common.checkPermission(this,permissions)) {
            hasPermission = false;
            imageView.setOnTouchListener(null);
            ActivityCompat.requestPermissions(this, permissions, 0);
        } else {
            hasPermission = true;
            imageView.setOnTouchListener(this);
            startCamera();
        }
    }

    private void startCamera() {
        ListenableFuture<ProcessCameraProvider> future = ProcessCameraProvider.getInstance(this);
        future.addListener(() -> {
            try {
                ProcessCameraProvider cameraProvider = future.get();

                Preview preview = new Preview.Builder().build();
                cameraProvider.unbindAll();
                ImageCapture.Builder builder1 = new ImageCapture.Builder();
                imageCapture = builder1.build();
                camera = cameraProvider.bindToLifecycle(this, cameraSelector, preview, imageCapture);

                preview.setSurfaceProvider(previewView.getSurfaceProvider());

                if (curBitmapPath != null) {
                    Bitmap bitmap = Common.loadImage(this, curBitmapPath);
                    imageView.setImageBitmap(bitmap);
                    int width = bitmap.getWidth();
                    int height = bitmap.getHeight();
                    onInitIm(width, height);
                }

            } catch (Exception e) {
                e.printStackTrace();
            }
        }, ContextCompat.getMainExecutor(this));

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == 0) {
            if (Common.checkPermission(ActivitySketching.this,permissions)) {
                hasPermission = true;
                imageView.setOnTouchListener(this);
                startCamera();
            } else {
                hasPermission = false;
                imageView.setOnTouchListener(null);
            }

        }
    }




    private void showNoPermission() {
        Toast.makeText(this, getString(R.string.permission_fail), Toast.LENGTH_SHORT).show();
    }


}